<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="名称" prop="name">
        <el-input
          v-model="queryParams.groupName"
          placeholder="请输入标签组名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          v-hasPermi="['vip:tagGroup:add']"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          v-hasPermi="['vip:tagGroup:edit']"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="tagGroupList" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />

      <el-table-column label="名称" align="center" prop="name" />
      <el-table-column label="销售公司" align="center" prop="companyName" min-width="140" show-overflow-tooltip />
      <el-table-column label="排序" align="center" prop="sortOrder" />
      <el-table-column label="标签" align="center" prop="tags" >
        <template slot-scope="scope" >
            <el-tag type="success" v-for="i in scope.row.tags" :key="i.id" style="margin: 2px 5px 0 0;">{{i.name}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            v-hasPermi="['vip:tagGroup:edit']"
            @click="handleUpdate(scope.row)"
          >修改</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改会员标签组对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">

        <el-form-item label="名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入名称"  />
        </el-form-item>
        <el-form-item label="排序" prop="sortOrder">
          <el-input-number v-model="form.sortOrder" :min="0" placeholder="请输入排序" />
        </el-form-item>
        <el-row>
          <el-col :span="3"><div style="margin-top: 9px;font-weight: bold;float: right; margin-right: 10px;">标签</div></el-col>
          <el-col :span="21">
            <el-table :data="form.tags">
              <el-table-column label="名称" prop="name" align="center" >
                <template slot-scope="scope">
                  <el-input v-model="scope.row.name"   ></el-input>
                </template>
              </el-table-column>
              <el-table-column label="排序" prop="sortOrder" align="center" >
                <template slot-scope="scope">
                  <el-input-number v-model="scope.row.sortOrder" :min="0" ></el-input-number>
                </template>
              </el-table-column>
              <el-table-column label="操作" width="150px" align="center">
                <template slot-scope="scope" >
                    <el-button @click="addRow" size="mini" type="text" >新增</el-button>
                    <el-button @click="deleteRow(scope.$index,scope.row)"   size="mini" type="text" v-if="form.tags.length>1">删除</el-button>
                </template>
              </el-table-column>
            </el-table>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listTagGroup, addTagGroup, getTagGroup, updateTagGroup } from "@/api/app/tag/tagGroup";
export default {
  name: "TagGroup",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 会员标签组表格数据
      tagGroupList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        groupName: null,
      },
      tagJson:[],
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        name: [
          { required: true, message: "名称不能为空", trigger: "blur" }
        ],
      }
    };
  },
  mounted() {
    this.handleQuery();
  },
  methods: {
    /** 查询会员标签组列表 */
    getList() {
      this.loading = true;
      listTagGroup(this.queryParams).then(response => {
        this.tagGroupList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        groupId: null,
        name: null,
        sortOrder: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    addRow() {
      this.form.tags.push({ name: "标签", sortOrder: 0},);
    },
    deleteRow(index,row) {
      this.form.tags.splice(index, 1);
      //存在groupId则是数据库中元数据，删除时需标记
      if (row.groupId) {
        if (!this.form.removeTagIds) {
          this.form.removeTagIds = [row.id];
        } else {
          this.form.removeTagIds.push(row.id);
        }
      }
    },

    /** 重置按钮操作 */
    resetQuery() {
      this.queryParams = {
        pageNum: 1,
        pageSize: 10,
        groupName: null,
      };
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.form.tags= [
        { name: "标签", sortOrder: 0},
      ];
      this.title = "添加会员标签组";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getTagGroup(id).then(response => {
        let td = response.data;
        if (!td.tags || td.tags.length === 0) {
          td.tags = [{ name: "标签", sortOrder: 0}]
        }
        this.form = td;
        this.open = true;
        this.title = "修改会员标签组";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateTagGroup(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addTagGroup(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
  }
};
</script>
